#pragma once

#include "libusb-1.0/libusb.h"

class StatusLight {
private:
    libusb_context *usbContext;
	libusb_device_handle *deviceHandle;

	/**
	 * Find the Status Light device on a USB bus and return it
	 * If the device is not found we get NULL
	 */
	libusb_device_handle* _getDevice();

	int _sendControlData(uint8_t buf[], uint8_t length);

public:
	StatusLight();
	~StatusLight();

	// void sendBlinkRate(int rate);
	void setColour(uint8_t r, uint8_t g, uint8_t b);

	void setLights(uint8_t r1, uint8_t g1, uint8_t b1, uint8_t r2, uint8_t g2, uint8_t b2, uint8_t r3, uint8_t g3, uint8_t b3);

	bool isConnected();
};
