#include <iostream>
#include <gtk/gtk.h>

#include "StatusLight.h"

using namespace std;

StatusLight light;

GtkAdjustment *redjustment;
GtkAdjustment *greenjustment;
GtkAdjustment *bluejustment;
GtkAdjustment *redjustment2;
GtkAdjustment *greenjustment2;
GtkAdjustment *bluejustment2;

static void destroy(GtkWidget *widget, gpointer data)
{
	gtk_main_quit();
}

void scale_adjustment(GtkWidget *widget, gpointer data)
{
	light.setLights(
		(uint8_t) gtk_adjustment_get_value(redjustment),
		(uint8_t) gtk_adjustment_get_value(greenjustment),
		(uint8_t) gtk_adjustment_get_value(bluejustment),
		(uint8_t) gtk_adjustment_get_value(redjustment2),
		(uint8_t) gtk_adjustment_get_value(greenjustment2),
		(uint8_t) gtk_adjustment_get_value(bluejustment2),
		(uint8_t) gtk_adjustment_get_value(redjustment),
		(uint8_t) gtk_adjustment_get_value(greenjustment),
		(uint8_t) gtk_adjustment_get_value(bluejustment)
	);
}

void run_gtk()
{
	GtkWidget *window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(window), 400, 200);
	g_signal_connect(window, "destroy", G_CALLBACK(destroy), NULL);

	GtkWidget *box = gtk_box_new(GTK_ORIENTATION_VERTICAL, 5);
	gtk_container_add(GTK_CONTAINER(window), box);

	redjustment = gtk_adjustment_new(0, 0, 255, 1, 10, 0);
	GtkWidget *scaleRed = gtk_scale_new(GTK_ORIENTATION_HORIZONTAL, GTK_ADJUSTMENT(redjustment));
	g_signal_connect(scaleRed, "value-changed", G_CALLBACK(scale_adjustment), NULL);
	gtk_box_pack_start(GTK_BOX(box), scaleRed, TRUE, TRUE, 0);

	greenjustment = gtk_adjustment_new(0, 0, 255, 1, 10, 0);
	GtkWidget *scaleGreen = gtk_scale_new(GTK_ORIENTATION_HORIZONTAL, GTK_ADJUSTMENT(greenjustment));
	g_signal_connect(scaleGreen, "value-changed", G_CALLBACK(scale_adjustment), NULL);
	gtk_box_pack_start(GTK_BOX(box), scaleGreen, TRUE, TRUE, 0);

	bluejustment = gtk_adjustment_new(0, 0, 255, 1, 10, 0);
	GtkWidget *scaleBlue = gtk_scale_new(GTK_ORIENTATION_HORIZONTAL, GTK_ADJUSTMENT(bluejustment));
	g_signal_connect(scaleBlue, "value-changed", G_CALLBACK(scale_adjustment), NULL);
	gtk_box_pack_start(GTK_BOX(box), scaleBlue, TRUE, TRUE, 0);

	redjustment2 = gtk_adjustment_new(0, 0, 255, 1, 10, 0);
	GtkWidget *scaleRed2 = gtk_scale_new(GTK_ORIENTATION_HORIZONTAL, GTK_ADJUSTMENT(redjustment2));
	g_signal_connect(scaleRed2, "value-changed", G_CALLBACK(scale_adjustment), NULL);
	gtk_box_pack_start(GTK_BOX(box), scaleRed2, TRUE, TRUE, 0);

	greenjustment2 = gtk_adjustment_new(0, 0, 255, 1, 10, 0);
	GtkWidget *scaleGreen2 = gtk_scale_new(GTK_ORIENTATION_HORIZONTAL, GTK_ADJUSTMENT(greenjustment2));
	g_signal_connect(scaleGreen2, "value-changed", G_CALLBACK(scale_adjustment), NULL);
	gtk_box_pack_start(GTK_BOX(box), scaleGreen2, TRUE, TRUE, 0);

	bluejustment2 = gtk_adjustment_new(0, 0, 255, 1, 10, 0);
	GtkWidget *scaleBlue2 = gtk_scale_new(GTK_ORIENTATION_HORIZONTAL, GTK_ADJUSTMENT(bluejustment2));
	g_signal_connect(scaleBlue2, "value-changed", G_CALLBACK(scale_adjustment), NULL);
	gtk_box_pack_start(GTK_BOX(box), scaleBlue2, TRUE, TRUE, 0);

	gtk_widget_show_all(window);

	gtk_main();
}

int main(int argc, char *argv[])
{
	int status = 0;

	if (light.isConnected()) {
		gtk_init(&argc, &argv);
		run_gtk();
	} else {
		status = -1;
	}

	return status;
}