#pragma once

#include <stdint.h>
#include <stdbool.h>

#include "ws2812/light_ws2812.h"
#include "ws2812_helpers.h"

#define NUM_LEDS 3
#define COLOR_COMPONENTS 3

// Colour correction/calibration factors
// Corrects for the different power of each LED colour to match RGB colours better to a screen.
// These will change depending on the exact parts and materials used to build this gadget.
#define CALIBRATION_RED 1.0
#define CALIBRATION_GREEN 0.603
#define CALIBRATION_BLUE 0.705

typedef enum LedDecoration {
    kLedDecoration_None = 0,
    kLedDecoration_Breathe,
} LedDecoration;

typedef enum LedFeature {
    kLedFeature_Transition = 0x1,
    kLedFeature_Calibration = 0x2,
    kLedFeature_BrightnessLookup = 0x4,
} LedFeature;

void led_set_all(cRGB colour);

void led_set_index(uint8_t index, cRGB colour);

void led_set_feature(LedFeature feature, bool enable);

void led_set_decoration(LedDecoration mode);

void led_update(void);
